/*
 * 2014/12/12 sample-002.c
 */

/*
 *
 */

#include <stdio.h>

/*
 *
 */

#include "int_stack.h"

/*
 *
 */

void push_and_print ( IntStack *isp, int data ) {

	printf ( "X^bN %d ς݂܂B\n", data );

	pushd_int_stack ( isp, data );	/* data  push */

}

/*
 *
 */

int pop_and_print ( IntStack *isp ) {
	int data;

	data = pop_int_stack ( isp );	/* data  pop */

	printf ( "X^bNof[^ %d łB\n", data );
	
	return data;
}

/*
 *
 */

int main ( int ac, char *av[] ) {
	IntStack stack;		/* X^bN̐錾 */

		/*
		 * X^bN𗘗pOɁAX^bN̏s
		 */

	clear_int_stack ( &stack );	/* |C^[n */

		/*
				uX^bNv̐݌vj
					uX^bNv́AuɐςށvƂčl
					uX^bN|C^[(sp)v́AuɃf[^ςޏꏊvƍl

						...
					+-----------+
				2	|			|
					+-----------+
				1	|			|
					+-----------+
				0	|			|		<- sp (stack_pointer) == 0
			--------+-----------+-----
		*/

		/*
		 * ŏɃX^bN 100 ς : push ( 100 )
		 */

	push_and_print ( &stack, 100 );

		/*
				f[^́ȕ݂ꏊvɕۑA
				sp ȕꏊvw悤ɂȂ

						...
					+-----------+
				2	|			|
					+-----------+
				1	|			|		<- sp (stack_pointer) == 1
					+-----------+
				0	|	100		|		X^bNgbvɂ 100 
			--------+-----------+-----
		*/

		/*
		 * X^bN 123 ς : push ( 123 )
		 */

	push_and_print ( &stack, 123 );

		/*

						...
					+-----------+
				2	|			|		<- sp (stack_pointer) == 2
					+-----------+
				1	|	123		|		X^bNgbvɂ 123 
					+-----------+
				0	|	100		|
			--------+-----------+-----
		*/

		/*
		 * X^bN 999 ς  : push ( 999 )
		 */

	push_and_print ( &stack, 999 );

		/*

						...
					+-----------+
				3	|			|		<- sp (stack_pointer) == 3
					+-----------+
				2	|	999		|		X^bNgbvɂ 999 
					+-----------+
				1	|	123		|
					+-----------+
				0	|	100		|
			--------+-----------+-----
		*/

		/*
		 * X^bNf[^o : pop() => 999 o
		 */

	pop_and_print ( &stack );

		/*

						...
					+-----------+
				3	|			|
					+-----------+
				2	|	999		|		<- sp (stack_pointer) == 2
					+-----------+
				1	|	123		|
					+-----------+
				0	|	100		|
			--------+-----------+-----
		*/

		/*
		 * xX^bNf[^o : pop() => 123 o
		 */

	pop_and_print ( &stack );

		/*

						...
					+-----------+
				3	|			|
					+-----------+
				2	|	999		|		<- f[^͏Ȃ(Ap֎~ !!)
					+-----------+
				1	|	123		|		<- sp (stack_pointer) == 1
					+-----------+
				0	|	100		|
			--------+-----------+-----
		*/

		/*
		 * X^bN 876 ς  : push ( 876 )
		 */

	push_and_print ( &stack, 876 );

		/*

						...
					+-----------+
				3	|			|
					+-----------+
				2	|	999		|		<- sp (stack_pointer) == 2
					+-----------+
				1	|	876		|		<- f[^͏㏑(͍̈ėp)
					+-----------+
				0	|	100		|
			--------+-----------+-----
		*/

		/*
		 * X^bNf[^o : pop() => 876 o
		 */

	pop_and_print ( &stack );

		/*

						...
					+-----------+
				3	|			|
					+-----------+
				2	|	999		|
					+-----------+
				1	|	876		|		<- sp (stack_pointer) == 1
					+-----------+
				0	|	100		|
			--------+-----------+-----
		*/

		/*
		 * X^bNf[^o : pop() => 100 o
		 */

	pop_and_print ( &stack );

		/*

						...
					+-----------+
				3	|			|
					+-----------+
				2	|	999		|
					+-----------+
				1	|	876		|
					+-----------+
				0	|	100		|		<- sp (stack_pointer) == 0 : 
			--------+-----------+-----
		*/

	return 0;
}

/*
 *
 */
